#!/usr/bin/python
__author__ = 'Piotr Matuszczyk <piotr.matuszczyk@sap.com>'

import json, requests

class Vrarestconnector:
  token = None
  errorlist = []
  
  def checkResponseError(self, response):
    acceptedResponses = [200, 201]
    if not response.status_code in acceptedResponses:
      erroccur = 1
      self.errorlist.append(erroccur)
      errtext = 'HTTP STATUS: '+str(response.status_code)+response.text
      self.errorlist.append(errtext)
    else:
      erroccur = 0
      self.errorlist.append(erroccur)
  
  def createToken(self, login, passwd, vrahost, tenant, timeout):
    headers = {
    'Content-Type': 'application/json',
    'Accept': 'application/json'
    }
    payload = {"username": login, "password": passwd, "tenant": tenant}
    url = 'https://' + vrahost + '/identity/api/tokens'
    try:
      response = requests.post(url=url, data=json.dumps(payload), headers=headers, verify=False, timeout=timeout)
    except requests.RequestException, e:
      self.errorlist.append('1')
      self.errorlist.append(e)
    else:
      self.checkResponseError(response)

    if self.errorlist[0] == 0:
      self.token = 'Bearer ' + response.json()['id']
      